console_status	equ	0xf881
console_data		equ	0xf883
byte_with_all_bits_set	equ	0xff

RTP_SEGMENT	equ	0xff00

;
; F000
;
	RTP_base	equ	$



; RTP_0000:	; 0E
	push	cs
; RTP_0001:	; 0809
	or	[bx+di],cl
; RTP_0003:	; 80044C
	add	byte	[si],0x4c
; RTP_0006:	; 0100
	add	[bx+si],ax
; RTP_0008:	; 03C0

	db	0x03, 0xC0
;;;	add	ax,ax


; RTP_000A:	; 056209
	add	ax,0x962
; RTP_000D:	; 000A
	add	[bp+si],cl
	add	[bp+di],cl
; RTP_0011:	; 56
	push	si
	push	cs
; RTP_0013:	; 020E0303
	add	cl,[0x303]
; RTP_0017:	; C105EA
	rol	word	[di],byte	0xea
; RTP_001A:	; 0F0000

	db	0x0F, 0x00, 0x00
;;;	sldt	[bx+si]		Run_Time_Package.asm:33: error: no instruction for this cpu level


; RTP_001D:	; 1000
	adc	[bx+si],al
; RTP_001F:	; 1009
	adc	[bx+di],cl
; RTP_0021:	; 40
	inc	ax
; RTP_0022:	; 044C
	add	al,0x4c
; RTP_0024:	; 0100
	add	[bx+si],ax
; RTP_0026:	; 03E0

	db	0x03, 0xE0
;;;	add	sp,ax



; RTP_0028:	; 056209
	add	ax,0x962
; RTP_002B:	; 000A
	add	[bp+si],cl
; RTP_002D:	; 000B
	add	[bp+di],cl
; RTP_002F:	; 56
	push	si
; RTP_0030:	; 0E
	push	cs
; RTP_0031:	; 020E0303
	add	cl,[0x303]
; RTP_0035:	; C105EA
	rol	word	[di],byte	0xea
; RTP_0038:	; 0F0000

	db	0x0F, 0x00, 0x00
;;;	sldt	[bx+si]		Run_Time_Package.asm:61: error: no instruction for this cpu level

; RTP_003B:	; 1000
	adc	[bx+si],al
; RTP_003D:	; 10D4
	adc	ah,dl
; RTP_003F:	; 30C4
	xor	ah,al
; RTP_0041:	; 0981066E
	or	[bx+di+0x6e06],ax
; RTP_0045:	; 049C
	add	al,0x9c
; RTP_0047:	; 033F
	add	di,[bx]
; RTP_0049:	; 039F01CE
	add	bx,[bx-0x31ff]
; RTP_004D:	; 006600
	add	[bp+0x0],ah
; RTP_0050:	; 43
	inc	bx
; RTP_0051:	; 0032
	add	[bp+si],dh
; RTP_0053:	; 0021
	add	[bx+di],ah
; RTP_0055:	; 0018
	add	[bx+si],bl
; RTP_0057:	; 000F
	add	[bx],cl
; RTP_0059:	; 000B
	add	[bp+di],cl
; RTP_005B:	; 0005
	add	[di],al
; RTP_005D:	;

	db	0x00
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RTP_005e:	; definitely code
	pushaw		; 0x 60
	mov	dx,0xf881

	push	ds
	push	cs

	pop	ds

	mov	bl,[cs:0x0]

	pop	ds

; RTP_006B:	; 32FF

	db	0x32, 0xFF	; force opcodes
;;	xor	bh,bh

; RTP_006D:	; 03DB

	db	0x03, 0xDB	; force opcodes
;;	add	bx,bx


; RTP_006F:	; BE0200
	mov	si, word 2
; RTP_0072:	; 1E
	push	ds
	push_w	14
; RTP_0076:	; B91000
	mov	cx,16
; RTP_0079:	; EB1B
	jmp	short	RTP_0096
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RTP_007b:	; 60		definitely code
	pushaw
	mov	dx,0xf880

; RTP_007F:	; 1E

	push	ds

	push	cs
	pop	ds

; RTP_0082:	; 2E8A1E0100
	mov	bl,[cs:0x1]
; RTP_0087:	; 1F

	pop	ds
; RTP_0088:	; 32FF
	xor_bh_bh

; RTP_008A:	; 03DB

	db	0x03, 0xDB
;;	add	bx,bx


; RTP_008C:	; BE2000
	mov	si, word 0x20
; RTP_008F:	; 1E
	push	ds
; RTP_0090:	; 680E00

	push_w	0xe

; RTP_0093:	; B91000
	mov	cx,0x10



RTP_0096:	; 0E
	push	cs
	pop	ds

RTP_0098:	; 6E
	outsb
	loop	RTP_0098
; RTP_009B:	; B00C

	mov	al,0xc
	out	dx,al

; RTP_009E:	; 8B473E

	mov	ax,[bx+0x3e]
	out	dx,al

; RTP_00A2:	; B00D

	mov	al,0xd
	out	dx,al
; RTP_00A5:	; 8AC4

	db	0x8A, 0xc4
;;	mov	al,ah


	out	dx,al
; RTP_00A8:	; 59
	pop	cx
RTP_00a9_loop:	; 6E
	outsb
	loop	RTP_00a9_loop
; RTP_00AC:	; 1F
	pop	ds
; RTP_00AD:	; 61
	popaw
; RTP_00AE:	; C3
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RTP_00af:

console_input_ready:

	push	dx
	in_al_from_addr		console_status

	and	al,0x1		; ready bit
	jz	.exit

	or	al,byte_with_all_bits_set

.exit:

	pop	dx
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


RTP_00bc:


console_get_char:
.loop:
	call	word	console_input_ready
	jz	.loop

	push	dx
	in_al_from_addr		console_data
	and	al,0x7f		; truncate character to 7-bit ASCII
	pop	dx

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RTP_00ca:

console_output_ready:
	push	dx

	in_al_from_addr		console_status

	and	al,4		; ready bit
	je	.exit
	or	al,byte_with_all_bits_set
.exit:
	pop	dx
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


RTP_00d7:

;
; data is in register AL 
;

console_put_char:
	push	ax
.loop:
	call	console_output_ready
	jz	.loop
	pop	ax
	push	dx
	mov	dx,console_data
	out	(dx),al
	pop	dx
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; Interrupt handler table
;

RTP_00e5:
	;	software interrupts:
	;
	dw	RTP_0274_Divide_error		- RTP_base
	dw	RTP_027A_Trap 			- RTP_base
	dw	RTP_0280_NMI			- RTP_base
	dw	RTP_027A_Trap			- RTP_base
	dw	RTP_0286_Overflow_trap		- RTP_base
	dw	RTP_028C_Bounds_trap		- RTP_base
	dw	RTP_0292_Illegal_opcode		- RTP_base
	dw	RTP_0298_ESC_instruction	- RTP_base


	dw	RTP_0260_handle_interrupt	- RTP_base
	dw	RTP_02BB_Unknown_interrupt	- RTP_base

	dw	RTP_0260_handle_interrupt	- RTP_base
	dw	RTP_0260_handle_interrupt	- RTP_base
	dw	RTP_0260_handle_interrupt	- RTP_base
	dw	RTP_0260_handle_interrupt	- RTP_base
	dw	RTP_0260_handle_interrupt	- RTP_base
	dw	RTP_0260_handle_interrupt	- RTP_base

	dw	RTP_02BB_Unknown_interrupt	- RTP_base
	dw	RTP_02BB_Unknown_interrupt	- RTP_base

	dw	RTP_026c	- RTP_base
	dw	RTP_0218	- RTP_base

	dw	RTP_02BB_Unknown_interrupt	- RTP_base
	dw	RTP_02BB_Unknown_interrupt	- RTP_base
	dw	RTP_02BB_Unknown_interrupt	- RTP_base
	dw	RTP_02BB_Unknown_interrupt	- RTP_base
	dw	RTP_02BB_Unknown_interrupt	- RTP_base
	dw	RTP_02BB_Unknown_interrupt	- RTP_base
	dw	RTP_02BB_Unknown_interrupt	- RTP_base
	dw	RTP_02BB_Unknown_interrupt	- RTP_base
	dw	RTP_026b	- RTP_base
	dw	RTP_02BB_Unknown_interrupt	- RTP_base
	dw	RTP_02BB_Unknown_interrupt	- RTP_base
	dw	RTP_02BB_Unknown_interrupt	- RTP_base

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RTP_0125:

RTP_string_CR_LF:
		db	CR, LF		; no null terminator

RTP_0127:


RTP_string_Bus_timeout:		db	"Bus timeout", 0  
RTP_string_Divide_error:	db	"Divide error", 0
RTP_string_Trap:		db	"Trap", 0
RTP_string_NMI:			db	"NMI", 0
RTP_string_Overflow_trap:	db	"Overflow trap", 0
RTP_string_Bounds_trap:		db	"Bounds trap", 0
RTP_string_Illegal_opcode:	db	"Illegal opcode", 0
RTP_string_ESC_instruction:	db	"ESC instruction", 0
RTP_string_Unknown_interrupt:	db	"Unknown interrupt", 0

RTP_string_0194:	db	":", 0

RTP_string_0196	db	CR, LF
		db	"CS:IP = ", 0

RTP_string_01a1:	db	"  SS:SP = ", 0

RTP_string_01ac:	db	"  DS = ", 0

RTP_string_01b4:	db	"  ES = ", 0

RTP_string_01bc:	db	CR, LF

RTP_string_01be:	db	"FL = ", 0

RTP_string_01c4:	db	"  AX = ", 0

RTP_string_01cc:	db	"  DX = ", 0

RTP_string_01d4:	db	"  CX = ", 0

RTP_string_01dc:	db	CR, LF
		db	"BX = ", 0

RTP_string_01e4:	db	"  BP = ", 0

RTP_string_01ec:	db	"  SI = ", 0

RTP_string_01f4:	db	"  DI = ", 0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
;
; F1FC
;

RTP_01FC_table:

	dw	RTP_string_0196	- RTP_base
	dw	RTP_string_0194	- RTP_base
	dw	RTP_string_01a1	- RTP_base
	dw	RTP_string_0194	- RTP_base
	dw	RTP_string_01ac	- RTP_base
	dw	RTP_string_01b4	- RTP_base
	dw	RTP_string_01bc	- RTP_base
	dw	RTP_string_01c4	- RTP_base
	dw	RTP_string_01cc	- RTP_base
	dw	RTP_string_01d4	- RTP_base
	dw	RTP_string_01dc	- RTP_base
	dw	RTP_string_01e4	- RTP_base
	dw	RTP_string_01ec	- RTP_base
	dw	RTP_string_01f4	- RTP_base

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RTP_0218:
	push	ax
	push	dx
	push	bx
	push	ds

; RTP_021C  B84000	;	data segment = 0x40

	mov	ax,0x40
	mov	ds,ax

; RTP_0221  33C0

	clr_ax

; RTP_0223  BB0200

	mov	bx,2
	inc	byte [bx]
	cmp	byte [bx],0x32
	jc	RTP_025C

; RTP_022D  8827
	mov	[bx],ah
	inc	bx

	mov	al,[bx]
; RTP_0232  FEC0
	inc	al
	daa
	mov	[bx],al
	cmp	al,0x60
	jc	RTP_025C


; RTP_023B  8827
	mov	[bx],ah
	inc	bx

	mov	al,[bx]
	inc	al
; RTP_0242  27
	daa
	mov	[bx],al
	cmp	al,0x60

	jc	RTP_025C


; RTP_0249  8827
	mov	[bx],ah
	inc	bx
	mov	al,[bx]
	inc al
	daa
	mov	[bx],al
	cmp	al,0x24
	jc	RTP_025C


; RTP_0257  8827
	mov	[bx],ah
	inc	bx
	inc	word [bx]


RTP_025C:
	pop	ds
	pop	bx
	jmp	short RTP_0262_skip
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RTP_0260_handle_interrupt:
	push	ax
	push	dx

RTP_0262_skip:
	out_at_port_data	Interrupt_Controller_end_of_interrupt, 0x8000

	pop	dx
	pop	ax
RTP_026b:
	iretw				; end of interrupt service routine

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


%if	1

%else

%endif

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

%macro	do_print_string_far	1
	push	bx
	mov	bx, word (%1 -RTP_base)
	jmp	word	print_string_at_bx
%endmacro

%macro	do_print_string	1
	push	bx
	mov	bx, word (%1 -RTP_base)
	jmp	short	print_string_at_bx
%endmacro


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RTP_026c:
	cli
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RTP_026D:	do_print_string_far	RTP_string_CR_LF
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RTP_0274_Divide_error:	do_print_string		RTP_string_Divide_error
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RTP_027A_Trap:		do_print_string		RTP_string_Trap
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RTP_0280_NMI:	do_print_string		RTP_string_NMI
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RTP_0286_Overflow_trap:	do_print_string		RTP_string_Overflow_trap
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RTP_028C_Bounds_trap:	do_print_string		RTP_string_Bounds_trap
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RTP_0292_Illegal_opcode:	do_print_string		RTP_string_Illegal_opcode
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RTP_0298_ESC_instruction:	do_print_string		RTP_string_ESC_instruction
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RTP_029E:	do_print_string		RTP_string_Return_from_subroutine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RTP_string_Return_from_subroutine:

	db	"Return from subroutine", 0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RTP_02BB_Unknown_interrupt:
	push	bx
	mov	bx,RTP_string_Unknown_interrupt	-RTP_base

	; fall through to next routine...
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RTP_02bf:
print_string_at_bx:
	call	word	print_Aztec_C_sign_on_message
	push	ds

	push	ax
	call	word	print_embedded_c_string
	pop	ax

	mov	bx,0x40
	mov	ds,bx
	mov	bx,	word	0x1c
	mov	[bx],sp
	mov	sp,ss
	mov	[bx+2],sp
	mov	bx,ds
	mov	ss,bx
	mov	sp,0x1c
;;;	mov	bx,sp
	db	0x8b,	0xdc	;	force opcodes

	lds	bx,[bx]
	push	word	[bx]

	push	es
	push	word	[bx+8]
	push	ax
	push	dx
	push	cx
	push	word	[bx+2]
	push	bp
	push	si
	push	di


	mov	bp,0x1c
	add	word	[bp+0],byte	+0xa
	add	bp,byte	+4

	mov	ax,[bx+4]
	mov	[bp+0],ax

	inc	bp
	inc	bp

	mov	ax,[bx+6]
	mov	[bp+0],ax

	mov	dx,0x40
	mov	ds,dx

	mov	bx,0x30
	mov	ss,bx

	mov	sp,0x100
	call	word	RTP_032B

	mov	dx,Interrupt_Controller_end_of_interrupt

	out_at_dx	0x8000

;
; Some kind of software deleay, loop 16384 times
;
	mov	ax,0x4000
.loop:
	dec	ax
	and_ax_ax
	jnz	.loop
;
;
;
	jmp	word	RTP_start	; RTP_04c9
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RTP_032B:
	mov	si,34
	mov	cx,14
	mov	di,0x1fc	;	0x1fc	offset to table in code segment at Lf1FC

;;;	00007334 2E8B1D                  	mov bx, [cs:di+0000]	fails
.loop:
	db	0x2e, 0x8b, 0x9d, 0,0	; force opcodes

	call	word	print_embedded_c_string
	mov	ax,[si]

	push	cx
	call	word	do_4_hex_digits
	pop	cx

	dec	si	
	dec	si	; si--

	inc	di
	inc	di	; di++

	loop	.loop
	sti
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RTP_034B:
;
;
;
message_034b:

	db	CR, LF, LF
	db	"----*****<<<<< Arcom SC88T initialisation v1.0>>>>>*****----"
	db	CR, LF, LF
	db	"                 ", 0

;
; Firmware was generated by Aztec C compiler.
;
;
RTP_039F:
message_Aztec_C_sign_on:
	db	CR, LF, 0
	db	"Aztec C runtime package for the Arcom SC88T Copyright (c) Reserved."
;

RTP_03e5:
print_embedded_c_string:
;;;	mov al,[cs:bx+0x0000]
	db	0x2e, 0x8A, 0x87, 0x00, 0x00	; get character from bx in code segment

	test	al,al		; is it null terminated?
	jz	ret_03f4	; yes, exit
	call	word	console_put_char	
	inc	bx		; next character
	jmp	short	print_embedded_c_string

ret_03f4:
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RTP_03f5:

print_Aztec_C_sign_on_message:
	push	ax
	push	bx
	push	ds
	mov	bx,0x39f	; offset to "Aztec C runtime package for the Arcom SC88T Copyright (c) Reserved."
				; message at RTP_039F 
	call	word	print_embedded_c_string
	pop	ds
	pop	bx
	pop	ax
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RTP_0402:
	
print_cx_hex_digits_from_ax:
				; some kind of hex function
	dec	cx		; cx is number of hex digits
	jz	.skip		; end of recursion
	push	ax
	shr	ax,4		; bits per nibble
	call	word	print_cx_hex_digits_from_ax	; recursion
	pop	ax
.skip:
	and	al,0xf		; least significant nibble
	daa			; decimal adjust so 
	add	al,0xf0
	adc	al,0x40		; 'A' - 1
	push	ds
	push_w	data_segment	; data is in RAM segment based at 0x0400
	pop	ds
	call	word	console_put_char
	pop	ds
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RTP_041e:

; Some routine for decimal digits

print_cx_digits_from_ax:
	
	mov	bl,10	
	div	bl		; divide by ten
	dec	cx		; decrement digit count
	jz	print_digits_from_0x400
;
	push	ax
	clr_ah
	call	word	print_cx_digits_from_ax
	pop	ax

print_digits_from_0x400:
	
Exit_F42C:
;;	mov	al,ah		; makes 0x88, 0xC4
	db	0x8A, 0xC4	; force opcodes
	and	al,0xf		; LS nibble only
	add	al,'0'		; convert nibble to ASCII
	push	ds
;
	push_w	data_segment		
	pop	ds
;
	call	word	console_put_char
	pop	ds
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


RTP_043C:
do_4_hex_digits:
	push	cx
	mov	cx,4		; 4 digits
	call	word	print_cx_hex_digits_from_ax
	pop	cx
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RTP_0445:


do_2_hex_digits:
	push	cx
	mov	cx,2		; 2 digits
	call	word	print_cx_hex_digits_from_ax
	pop	cx
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



RTP_044E:

str_K_bytes_of_memory:

	db	"K bytes of memory", CR, LF, LF, LF, 0
RTP_0464:
 
find_out_RAM_size:
	mov	cx,256

	clr_ax
	mov	es,ax

	mov	bx,0x1fff		; for an 8K block
	mov	cx,32			; 32 x 8K = 256K max size

					; we could raise that limit
      
.loop1:
	; Write byte 0x55
	
	mov	byte	[es:bx],0x55

	add	ax,0x200		; 
	mov	es,ax			; extra segment starts at at 0x02000


	loop	.loop1

	clr_ax				; 
	mov	es,ax
;
.loop2:
	not	byte   [es:bx]		; read-invert-write the RAM data
	mov	dl,[es:bx]		; then read it 

	cmp	dl,0xaa			; have we got the expected data?
	jne	first_non_RAM_address_found

	add	ax,0x200
	mov	es,ax			; extra segment starts at at 0x02000
	jmp	.loop2

first_non_RAM_address_found:

RTP_0492:
	nop
;	RTP_0493 c1 e8 06                         
	shr	ax,6
;	RTP_0496 68 40 00                         
	push_w	data_segment
	pop	ds
; RTP_049a 50                               
	push	ax
; RTP_049b a3 00 00
	mov	[0],ax
; RTP_049e b9 04 00                        
	mov	cx,4		; 4 digits                     
	call	print_cx_digits_from_ax
; RTP_04a4 58                               
	pop	ax
; RTP_04a5 bb 00 80
	mov	bx,0x8000
; RTP_04a8 
	shl	ax,7

.loop3:
	shr	bx,1
	shl	ax,1
	jae	.loop3

;RTP_04b1 85 c0
	test   ax,ax
	je     .skip	; RTP_04b7

;RTP_04b5
	db	0xd1, 0xe3 	;	shl    bx
.skip:
	db	0x8b, 0xc3 	;	mov    bx,ax		force opcodes

;	000074B7 89C3                    	mov	bx,ax
;	000074B7 89D8                    	mov	ax,bx
;
; Now have the size of the RAM, so reprogram LMCS.
;
RTP_04b9:
	dec	ax		; gets the last working RAM address
	and	al,0xf8		; sets the boundary
	or	al,0		; adds the RAM wait state selection
	
	
	out_ax_at_addr	LMCS	;  


	mov	bx,0x44e	; the "K bytes of memory", CR, LF, LF, LF, 0 string
	call	print_embedded_c_string
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RTP_04c9:


; ff00.
; .04c9
; ff4c9 = not in the top 32K!
; Maybe this is the run-time package at F8000,
; and another 32K ROM is expected    at F0000.
;
RTP_start:	
	cli				; db	0xfa	clear interrupt flag



	out_at_port_data	Interrupt_Controller_status, 0x8000	; i.e. 0xff30, 0x8000
  	out_at_port_data	IO_relocation_register, 0xa0ff		; i.e. 0xfffe, 0xa0ff	


	out_at_port_data	LMCS, LMCS_INITIAL_VALUE
	out_at_port_data	MPCS, MPCS_INITIAL_VALUE
	out_at_port_data	PACS, PACS_INITIAL_VALUE
	
	out	(dx),al			; db	ee

	mov	ax,data_segment		;		b8 40 00
	mov	ss,ax			;		8e d0

	mov	sp,0x0024		;		bc 24 00

	mov	ax,data_segment		;		b8 40 00
	mov	ds,ax			;		8e d8

	cld				;		fc

	mov	dx,Interrupt_Controller_in_service
	clr_ax
	out	(dx),ax

	sti				;		fb	set interrupt flag

	mov	ax,cs			;		8c c8
	mov	ds,ax			;		8e d8	data seg == code seg
	mov	es,ax			;		8e c0	extra seg = code seg

RTP_0509:


	call	RTP_005e			;		e8 52 fb
	call	RTP_007b			;		e8 6c fb

	mov	bx,0x034b		; offset to "----*****<<<<< Arcom SC88T initialisation v1.0>>>>>*****----"

	call	print_embedded_c_string			; 



	mov	si,0x00e5		; db	0xbe, 0xe5, 0
	clr_ax
	mov	es,ax

	db	0x8b, 0xf8		;	mov	di,ax	;	force opcodes

	mov	cx,0x0020

	mov	ax,cs		;	

RTP_0523:
.loop1:
	movsw			;	movsw	[ds:si],[es:di]

	stosw
	loop	.loop1
	mov	cx,32		; 
.loop2:

	mov	ax,0x02bb		; 
	stosw

	mov	ax,cs
	stosw

	loop	.loop2


	mov	ax,0x0040		;	64 decimal
	mov	es,ax
	clr_ax
	mov	cx,3
	mov	di,2
	rep	stosw

	mov	di,8		;
	mov	cx,14
	rep stosw		;
	
	mov	ax,8		;
	stosw			;

	mov	ax,ds
	stosw

	clr_ax			;
	stosw			;

	mov	ax,0xffff	;
	stosw			;


	;	+C0 to +CA	DMA Descriptors Channel 0
	
	mov	ax,0x9204		; 

	out_ax_at_addr	DMA_channel_0_control_word		; 
	out_ax_at_addr	DMA_channel_0_control_word		; 

	mov	ax,0x4000		; 


	;	+50 to +56		Timer 0 Control
	
	out_ax_at_addr	Timer_0+6		;
	out_ax_at_addr	Timer_0+14		; 

	;	+60 to +66		Timer 2 Control

	out_ax_at_addr	Timer_2+6		; 

	mov	ax,0x001f		; 31 decimal

	out_ax_at_addr	Interrupt_Controller_interrupt_0_control
	out_ax_at_addr	Interrupt_Controller_interrupt_1_control
	out_ax_at_addr	Interrupt_Controller_interrupt_2_control
	out_ax_at_addr	Interrupt_Controller_interrupt_3_control

	mov	dx,Interrupt_Controller_status

	clr_ax				; 
	out	(dx),ax			; 

	;	FF00	+20 to +3E		Interrupt Controller
	
	out_ax_at_addr	Interrupt_Controller_interrupt_request 

	mov	dx,Interrupt_Controller_priority	; db	0xba, 0x2a, 0xff
	out_at_dx	7

	mov	dx,Interrupt_Controller_in_service	; db	0xba, 0x2c, 0xff

	clr_ax				; 
	out	(dx),ax			; 
	db	0xfb



	mov	dx,Timer_0		; Timer 0
	clr_ax				; 
	out	(dx),ax			; out	(Timer_0), 0

	inc_dx_twice

	inc	ax			; Set max count A = 1
	out	(dx),ax			; out	(Timer_0+2), 1

	inc_dx_twice			; Set max count B = 1

	out	(dx),ax			; out	(Timer_0+4), 1

	inc_dx_twice

	out_at_dx	0xc003		; Mode control word (Timer_0+6) = 0xc003

	inc_dx_twice			; Timer 1

	clr_ax				; 

	out	(dx),ax			; out	(Timer_1), 0

	inc_dx_twice

	out_at_dx	0x0028		; Set max count A = 40		out	(Timer_1+2), 0x28

	inc_dx_twice

	out_at_dx	0x0001		; Set max count B = 1		out	(Timer_1+4), 1

	inc_dx_twice

	out_at_dx	0xe013		; Mode control word = 		out	(Timer_1+6), 0xe013

; F5C7: ba 32ff 33c0

	mov	dx,Interrupt_Controller_level_0_timer_0		; db	0xba, 0x32, 0xff
	clr_ax				; 
	out	(dx),ax			; 
	
	call	find_out_RAM_size			; db	0xe8, 0x94, 0xfe
	
;  F5D0
	
	mov	ax,[0]			; db	0xa1, 0, 0,



;;	sub	ax, word 0x0002		; db	0x2d, 0x02, 0
	db	0x2d, 0x02, 0		; force it to use 16-bit form!



	shl	ax,10			; db	0xc1, 0xe0, 0x0a
	mov	bx,128			; db	0xbb, 0x80
	mov	ss,bx			; db	0x8e, 0xd3


;;;	mov	sp,ax			; db	0x8b, 0xe0
	db	0x8b, 0xe0		; force these opcodes
;
;
; Finally call the application code in an endless loop.
;
;
;
%if	0
;
; original ROM
;
loop_1:
	call	word	0xf800:0x0

	jmp	word	loop_1	; 0x75e0
;
; Lots of spare room here:
;
RTP_05f0:	times	(2568) db 0
%else
;
; key pressed determines which test routine is called.
;
loop_1:
	call	console_get_char
	cmp	al,'0'
	jnz	.skip0
	call	test_0			; 0 = no test
.skip0:
	cmp	al,'1'
	jnz	.skip1
	call	test_1
.skip1:
	cmp	al,'2'
	jnz	.skip2
	call	test_2
.skip2:
	cmp	al,'3'
	jnz	.skip3
	call	test_3
.skip3:
	cmp	al,'4'
	jnz	.skip4
	call	test_4			; select test of choice
.skip4:
	cmp	al,'5'
	jnz	.skip5
	call	test_5
.skip5:
	cmp	al,'6'
	jnz	.skip6
	call	test_6
.skip6:
	cmp	al,'7'
	jnz	.skip7
	call	test_7
.skip7:
	cmp	al,'8'
	jnz	.skip8
	call	test_8
.skip8:
	cmp	al,'9'
	jnz	.skip9
	call	test_9
.skip9:
;
	jmp	word	loop_1		; endless loop as before
;
; Now assemble the tests themselves:
;
; 0. Just halt.
;
test_0:


test_7:
test_8:

	ret

;
; Echo characters. This works.
;
; Works best with hardware handshaking on the terminal program.
; The handshake tells the PC to stop sending while the board is busy.
; This stops characters being sent and missed.
;
test_1:	

	call	console_get_char
	call	console_put_char	; saves return instruction
	jmp	test_1			; Loops forever, you have to reset to escape.

test_2:

	mov	ax,0xab
	jmp	do_2_hex_digits

test_3:

	mov	ax,0xcdef
	jmp	do_4_hex_digits
;

;
; hello world
;
; This prints message then locks up.
; Probably needs print_embedded_c_string() instead
;
;
test_4:
	do_print_string_far	RTP_string_Hello_World
;;;	ret	is not needed, but add one anyway
	ret

RTP_string_Hello_World:
	db	"Hello World!", LF, 0
;
;
; 5 hex print from data segment. This works.
;
test_5:
	mov	cx,0x0200		; 32K - 4K is 7000h
	xor	bx,bx			; offset is zero
.loop:
	xor	ah,ah			; clear high byte

;;;	mov	al, byte [bx] 		; this gets data from default segment, RAM, which is no use for verification.
	mov	al, byte [cs:bx] 	; this gets data from RTP code segment, correctly.
	inc	bx

	call	do_2_hex_digits
	mov	ax,0x20			; space
	call	console_put_char

	loop	.loop			; like djnz of z80

	ret

;
; 6 hex print from specified data segment. This works.
;
test_6:
	mov	cx,0x0200		; 32K - 4K is 7000h
	xor	bx,bx			; offset is zero

.loop:
	push	ds
	mov	ax,0xf800		; specified data segment
	mov	ds,ax

	xor	ah,ah			; clear high byte

	mov	al, byte [bx] 		; get from other segment
	inc	bx

	pop	ds			

	call	do_2_hex_digits
	mov	ax,SPACE
	call	console_put_char

	loop	.loop			; like djnz of z80

	ret


;
; 9. Original application crashes, expecting boards that are not there.
;
; 
;
test_9:	

.loop_1:
	call	word	0xf800:0x0	; exact bytes as in original code

	jmp	word	.loop_1		; endless loop
;
; Now fill ROM up to FFF0:
;
	RTP_05f0:	times	(0x95d) db 0
%endif


;
LFFF0:
;
;	1111 1000 0011 1110
;

	RTP_ENTRY	equ	RTP_start-0xF000

;
; FFFF0h - FFFFFh - after RESET the processor always 
; starts program execution at the FFFF0h address.
;
RESET_0000:				; First job is to program the on-chip control register
;
	out_at_port_data	UMCS,UMCS_INITIAL_VALUE
	jmp   RTP_SEGMENT:RTP_ENTRY
;
; The single line of code above tells us a lot about the software.
;
;
	dw	0, 0			; unused

