;
; For this board:
;
UMCS_INITIAL_VALUE	equ	0xf83e			; 32K ROM
;	fedcba98 76 543 210
;	11111000 00 111 110
;
; Initially set LCS for the maximum (256K) size
; and let the RTP test for the real size later.
;
LMCS_INITIAL_VALUE	equ	0x3ff8			; 16K RAM 

;	07F8H	;	32K
;	0FF8H	;	64K
;	1FF8H	;	128K
;	3FF8H	;	256K

; MMCS_INITIAL_VALUE	equ	0			; No middle memory used here!
MPCS_INITIAL_VALUE	equ	0x80b8			; PCS are in I/O space
;	fedcba98 76 543 210
;	1mmmmmmm em 111 rrr
;	10000000 10 111 000

PACS_INITIAL_VALUE	equ	0x0fbe		; PCS are in I/O space, at 128-byte intervals
;	fedcba9876 543 210
;	uuuuuuuuuu 111 rrr PACS
;	0000111110 111 110	start 0F80, 2 waits states, ignore RDY


